/*------------------------------------
 * hotkey.h -  Fekete Krisztian
 * fekete.krisztian@freemail.hu
 *------------------------------------
 */

#include "xlib.h"

#ifndef __HOTKEY_H__INCLUDED
#define __HOTKEY_H__INCLUDED

#include <stdio.h>
#include "lang.h"

typedef enum {
     PT_EXACT,
     PT_REGEXP
} Pattern_type;

typedef struct {
     char* pattern;
     Pattern_type type;
} Pattern;

typedef struct {
     GUI_modifier_mask modifiers;
     GUI_key_code key_code;
     Pattern winclass;
     Pattern winname;
     Pattern wintitle;
     Pattern wincommand;
     yesno iconify;
     char* prog;
     char* dir;
     char* hk_name;
} Hotkey;

declglob hotkey_read(FILE* f, Hotkey* hk);
declglob hotkey_free(Hotkey** hk);
declglob hotkey_has_action(const Hotkey* hk);
declglob hotkey_has_pattern(const Hotkey* hk);

#endif /* __HOTKEY_H__INCLUDED */
