/*------------------------------------
 * lang.h -  Fekete Krisztian
 * fekete.krisztian@freemail.hu
 *------------------------------------
 */

#ifndef __LANG_H__INCLUDED
#define __LANG_H__INCLUDED

#include <assert.h>

#define declglob int
#define defglob int

#define decl static int
#define def static int

#define fail return 0
#define succeed return 1

typedef enum {yes = 1, no = 0} yesno;

#define streq(s1, s2) (0 == strcmp(s1, s2))
#define strless(s1, s2) (strcmp(s1, s2) < 0)

extern yesno debug;
extern const char* prog_name;

#include <unistd.h>             /* for getpid() */
#include <stdio.h>              /* for printf() */
#define IFDEBUG(stmt) if (debug) {                                         \
                          printf("%s:%5d :%12s: %5d: ",                       \
                                 prog_name, getpid(), __FILE__, __LINE__); \
                          stmt;                                            \
                          printf("\n");                                    \
                      }

#endif /* __LANG_H__INCLUDED */
