/*------------------------------------
 * str_lib.c -  Fekete Krisztian
 * fekete.krisztian@freemail.hu
 *------------------------------------
 */

#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "str_lib.h"

defglob str_init(
     string * str)
{
     str->bufsize = 1;
     str->str = malloc(str->bufsize);
     str->length = 0;
     if (str->str) {
          str->str[str->length] = 0;
        
          succeed;
     }
     fail;
}

defglob str_to_cstr(
     string * str,
     char * *cstr)
{
     *cstr = str->str;
     str->str = 0;
     str->length = 0;
     str->bufsize = 0;
    
     if (*cstr) {
          succeed;
     }
     fail;
}

defglob str_uninit(
     string* str)
{
     free(str->str);
    
     succeed;
}

def str_enlarge(
     string * str)
{
     char * s;
     s = malloc(2 * str->bufsize);
     if (s) {
          memcpy(s, str->str, str->length + 1);
          free(str->str);
          str->str = s;
          str->bufsize += str->bufsize;
        
          succeed;
     }
     fail;
}

defglob str_append(
     string * str,
     char c)
{
     if (str->length + 1 >= str->bufsize) {
          if (!str_enlarge(str)) {
               fail;
          }
     }
    
     str->str[str->length] = c;
     str->length ++;
     str->str[str->length] = 0;
    
     succeed;
}

defglob str_remove_first(
     string * str,
     char *c)
{
     if (str->length) {
          *c = str->str[0];
          memmove(str->str, str->str+1, str->length);
          str->length --;
          succeed;
     }
    
     fail;
}

defglob str_trim_left(
     string * str)
{
     char c;
    
     while (isspace(str->str[0]) && str_remove_first(str, &c)) {
          ;
     }
    
     succeed;
}

defglob read_word(
     string * input_stream,
     string * word)
{
     char c;
    
     if (!str_init(word) || !str_trim_left(input_stream)) {
          fail;
     }
     while (str_remove_first(input_stream, &c) && !isspace(c)) {
          if (!str_append(word, c)) {
               str_uninit(word);
               fail;
          }
     }
    
     succeed;
}

defglob read_line(
     FILE * f,
     string * line)
{
     int c;
    
     if (!str_init(line)) {
          fail;
     }
     c = getc(f);
     if (EOF == c) {
          str_uninit(line);
          fail;
     }
     while (c != EOF && c != '\n') {
          if (!str_append(line, c)) {
               str_uninit(line);
               fail;
          }
          c = getc(f);
     }
    
     succeed;
}

/* end of file */
