/*------------------------------------
 * str_lib.h -  Fekete Krisztian
 * fekete.krisztian@freemail.hu
 *------------------------------------
 */

#ifndef __STR_LIB_H__INCLUDED
#define __STR_LIB_H__INCLUDED

#include <stdio.h>
#include "lang.h"

typedef struct
{
    char * str;
    int bufsize;
    int length;
} string;

declglob str_init(string* str);
declglob str_to_cstr(string* str, char** cstr);
declglob str_uninit(string* str);
declglob str_append(string* str, char c);
declglob str_remove_first(string* str, char* c);
declglob str_trim_left(string* str);
declglob read_word(string* input_stream, string* word);
declglob read_line(FILE* f, string* line);

#endif /* __STR_LIB_H__INCLUDED */
