/*------------------------------------
 * winlist.c -  Fekete Krisztian
 * fekete.krisztian@freemail.hu
 *------------------------------------
 */

#include "xlib.h"
#include <stdio.h>
#include <stdlib.h>

def print_win_class_name_and_title(
     GUI_window w)
{
     char* title;
     char* class;
     char* name;
     
     printf("\n{\nwindow: %x\n", (int)w);
     if (gui_get_window_class(w, &class))
     {
          printf("class: %s\n", class);
          free(class);
     }
     if (gui_get_window_name(w, &name))
     {
          printf("name: %s\n", name);
          free(name);
     }
     if (gui_get_window_title(w, &title))
     {
          printf("title: %s\n", title);
          free(title);
     }
     if (gui_get_window_command(w, &title))
     {
          printf("command: %s\n", title);
          free(title);
     }
     printf("}\n");
     succeed;
}

yesno debug = no;
const char* prog_name = "winlist";

int
main(
     int argc,
     char** argv)
{
     GUI_window* window_list;
     int n;

     (void)argv;
     if (argc > 1) {
          debug = yes;
     }
     
     if (!gui_init()) {
          fprintf(stderr, "Cannot open X display\n");
          return 1;
     }
     
     printf("window list:\n");
     printf("------------\n");
     if (gui_get_window_list(&window_list, &n)) {
          int i;
          for (i = 0; i < n; i ++) {
               print_win_class_name_and_title(window_list[i]);
          }
          gui_uninit();
     }
     return 0;
}

/* end of file */
