/*------------------------------------
 * xlib.h -  Fekete Krisztian
 * fekete.krisztian@freemail.hu
 *------------------------------------
 */

#ifndef __xlib_h__included
#define __xlib_h__included

#include <X11/Xlib.h>           /* GUI_window */
#include "lang.h"

typedef Window GUI_window;
typedef int GUI_modifier_mask;
typedef KeyCode GUI_key_code;

typedef enum {
     GUI_SHIFT   = (1 << 0),
     GUI_CONTROL = (1 << 1),
     GUI_ALT     = (1 << 2),
     GUI_META    = (1 << 3),
     GUI_SUPER   = (1 << 4),
     GUI_HYPER   = (1 << 5)
} GUI_modifier;

#include "hotkey.h"

extern yesno gui_error_occured;
declglob gui_clear_error();
declglob gui_get_error_text(char* buffer, int length);

declglob gui_init();
declglob gui_uninit();
declglob gui_string_to_key(const char* str, GUI_key_code* key_code);
declglob gui_run_event_loop(int (*exec_hotkey)(Hotkey*));
declglob gui_register_hotkey(Hotkey* hk);
declglob gui_unregister_hotkeys();
declglob gui_bring_to_front(GUI_window w);
declglob gui_is_visible(GUI_window w);
declglob gui_iconify(GUI_window w);
declglob gui_get_window_class(GUI_window w, char** class);
declglob gui_get_window_name(GUI_window w, char** name);
declglob gui_get_window_title(GUI_window w, char** title);
declglob gui_get_window_command(GUI_window w, char** command);
declglob gui_get_window_list(GUI_window** window_list, int* n);
declglob gui_message(const char* title, const char* msg);

#endif /* __xlib_h__included */
/* end of file */
